ORG 0
BITS 32
; ---------------------------------------------------------------------------- ;
STACK_SIZE     equ 1024
; ---------------------------------------------------------------------------- ;
MENUET01       db 'MENUET01'
version        dd 1
program.start  dd START
program.end    dd END
program.memory dd END + STACK_SIZE
program.stack  dd END + STACK_SIZE
program.params dd 0
program.path   dd 0
; ---------------------------------------------------------------------------- ;
sz_caption     db "test",0
szAllZero      db "All Zero",0
szSomeNotZero  db "Some Not Zero",0
Result dd szAllZero
; ---------------------------------------------------------------------------- ;
SECTION .bss
MemoryBuffer resb 1024 * 1024 * 1024
.end:
; ---------------------------------------------------------------------------- ;
SECTION .text
sz_con_init           db "con_init",0
sz_con_write_asciiz   db "con_write_asciiz",0
sz_con_exit           db "con_exit",0
sz_console            db "/sys/lib/console.obj",0
; ---------------------------------------------------------------------------- ;
con_init              dd 0
con_write_asciiz      dd 0
con_exit              dd 0
; ---------------------------------------------------------------------------- ;
START:
; load library
        mov    eax, 68
        mov    ebx, 19
        mov    ecx, sz_console
        int    64
        mov    ecx, eax
        mov    ebx, GetProcAddress
        push   ecx
        push   sz_con_init
        call   ebx
        mov    [con_init], eax
        push   ecx
        push   sz_con_write_asciiz
        call   ebx
        mov    [con_write_asciiz], eax
        push   ecx
        push   sz_con_exit
        call   ebx
        mov    [con_exit], eax

        push   sz_caption
        push   -1
        push   -1
        push   -1
        push   -1
        call   [con_init]
;-------------------------------------------------
        mov    edi, MemoryBuffer
        mov    ecx, MemoryBuffer.end - MemoryBuffer
        xor    eax, eax
        repe   scasb
        je     .ok
        mov    Dword [Result], szSomeNotZero
.ok:
        push   Dword [Result]
        call   [con_write_asciiz]
;-------------------------------------------------
; exit and terminate
        push   0
        call   [con_exit]
        or     eax, -1
        int    64
; --------------------------------------------- ;
GetProcAddress:
        mov    edx, [esp + 8]
        xor    eax, eax
        test   edx, edx
        jz     .end
.next:
        xor    eax, eax
        cmp    [edx], dword 0
        jz     .end
        mov    esi, [edx]
        mov    edi, [esp + 4]
.next_:
        lodsb
        scasb
        jne    .fail
        test   al, al
        jnz    .next_
        jmp    .ok
.fail:
        add    edx, 8
        jmp    .next
.ok:
        mov    eax, [edx + 4]
.end:
        ret    8
; ---------------------------------------------------------------------------- ;
END: